﻿using System.Linq.Expressions;
using XF.Domain.Entities;

namespace Hotline.Repository.SqlSugar.DataPermissions;

public interface IDataPermissionFilterBuilder
{
    IDataPermissionManager DataPermissionManager { get; }
    Expression<Func<TEntity, bool>> Build<TEntity>()
        where TEntity : class, IEntity<string>, IDataPermission, new();

    Expression<Func<TEntity, bool>> BuildIncludeFlowData<TEntity>()
        where TEntity : class, IEntity<string>, IDataPermission, IWorkflow, new();
}