﻿using Hotline.Share.Enums.CallCenter;
using XF.Utility.EnumExtensions;

namespace Hotline.Share.Dtos.CallCenter
{
    public class TelDto
    {
        /// <summary>
        /// 主键
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 分机号
        /// </summary>
        public string No { get; set; }

        public DateTime CreationTime { get; set; }

        /// <summary>
        /// 上线IP
        /// </summary>
        public string RegisterIP { get; set; }

        /// <summary>
        /// 分机线路编号
        /// </summary>
        public string LineId { get; set; }

        /// <summary>
        /// 分机状态
        /// </summary>
        public ETelStatus TelStatus { get; set; }

        /// <summary>
        /// 主叫
        /// </summary>
        public string CPN { get; set; }

        /// <summary>
        /// 被叫
        /// </summary>
        public string CDPN { get; set; }

        /// <summary>
        /// 呼叫中心通话ID
        /// </summary>
        public string? CallId { get; set; }

        /// <summary>
        /// 扩展内容（讯时设备产生的临时唯一标识：VisitorId 或 OuterId）
        /// </summary>
        public string ConversationId { get; set; }
        /// <summary>
        /// 分机详细状态
        /// </summary>
        public ETelStatusInfo TelStatusInfo { get; set; }

        public string TelStatusText => TelStatus.GetDescription();

        public string TelStatusInfoText => TelStatusInfo.GetDescription();

        public string GroupNames => string.Join(",", Groups?.Select(x => x.Name) ?? new List<string>());

        public List<TelGroupDto> Groups { get; set; }
    }
}
