﻿using Hotline.Share.Enums.Order;
using XF.Utility.EnumExtensions;

namespace Hotline.Share.Dtos.Users;


public record UserDto : AddUserDto
{
    public string Id { get; set; }

    public string GenderText => Gender.GetDescription();

    public DateTime CreationTime { get; set; }

    public string OrgName { get; set; }

    public string Roles { get; set; }
    
    public string State { get; set; }
}

public record AddUserDto
{
    public string UserName { get; set; }

    /// <summary>
    /// 手机号(冗余)
    /// </summary>
    public string? PhoneNo { get; set; }

    /// <summary>
    /// 展示名称(Identity.DisplayName)
    /// </summary>
    public string Name { get; set; }

    public EGender Gender { get; set; }

    /// <summary>
    /// 工号
    /// </summary>
    public string? StaffNo { get; set; }

    /// <summary>
    /// 部门Id
    /// </summary>
    public string? OrgId { get; set; }

    /// <summary>
    /// 部门编码（冗余）
    /// </summary>
    public string? OrgCode { get; set; }

    /// <summary>
    /// 默认分机号
    /// </summary>
    public string? DefaultTelNo { get; set; }

    public string Email { get; set; }
}

public record UpdateUserDto
{
    public string Id { get; set; }

    /// <summary>
    /// 手机号(冗余)
    /// </summary>
    public string? PhoneNo { get; set; }

    /// <summary>
    /// 展示名称(Identity.DisplayName)
    /// </summary>
    public string Name { get; set; }

    public EGender Gender { get; set; }

    /// <summary>
    /// 工号
    /// </summary>
    public string? StaffNo { get; set; }

    /// <summary>
    /// 部门Id
    /// </summary>
    public string? OrgId { get; set; }

    /// <summary>
    /// 部门编码（冗余）
    /// </summary>
    public string? OrgCode { get; set; }

    /// <summary>
    /// 默认分机号
    /// </summary>
    public string? DefaultTelNo { get; set; }

    public string Email { get; set; }
}