﻿using SqlSugar;
using XF.Domain.Entities;
using XF.Domain.Repository;

namespace Hotline.CallCenter.Ivrs;

/// <summary>
/// IVR语音导航节点分类
/// </summary>
public class IvrCategory : CreationEntity
{
    /// <summary>
    /// 分类名称
    /// </summary>
    public string Name { get; set; }

    /// <summary>
    /// 备注
    /// </summary>
    [SugarColumn(IsNullable = true)]
    public string? Remark { get; set; }
    
    public int Sort { get; set; }

    [Navigate(NavigateType.OneToMany, nameof(Ivr.IvrCategoryId))]
    public List<Ivr> Ivrs { get; set; }
}