﻿using Hotline.FlowEngine.Definitions;
using Hotline.FlowEngine.Workflows;
using Hotline.Share.Dtos.FlowEngine;
using MediatR;
using XF.Domain.Entities;

namespace Hotline.FlowEngine.Notifies;

public record WorkflowNotify(Workflow Workflow, StepDefine StepDefine, BasicWorkflowDto Dto) : INotification;

public record StartWorkflowNotify(Workflow Workflow, StepDefine StepDefine, BasicWorkflowDto Dto, bool IsCountersignStart) : WorkflowNotify(Workflow, StepDefine, Dto);

public record NextStepNotify(Workflow Workflow, StepDefine StepDefine, BasicWorkflowDto Dto, bool IsCountersignStart, bool IsCountersignEnd) : WorkflowNotify(Workflow, StepDefine, Dto);

public record AcceptWorkflowNotify(Workflow Workflow) : INotification;

public record CountersignEndAssigned(Workflow Workflow) : INotification;

public record PreviousStepNotify(PreviousWorkflowDto Data) : INotification;

public record EndWorkflowNotify(Workflow Workflow) : INotification;

public record TerminalWorkflowNotify(Workflow Workflow) : INotification;