﻿using Hotline.Share.Enums.KnowledgeBase;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.KnowledgeBase;

/// <summary>
/// 知识库文档内容
/// </summary>
public class Knowledge : FullStateEntity
{
    /// <summary>
    /// 知识分类
    /// </summary>
    public string KnowledgeTypeId { get; set; }

    /// <summary>
    /// 热点
    /// </summary>
    public string HotspotId { get; set; }

    /// <summary>
    /// 知识编号
    /// </summary>
    public string Code { get; set; }

    /// <summary>
    /// 标题
    /// </summary>
    public string Title { get; set; }

    /// <summary>
    /// 摘要
    /// </summary>
    public string Summary { get; set; }

    /// <summary>
    /// 内容
    /// </summary>
    public string Content { get; set; }

    /// <summary>
    /// 浏览量
    /// </summary>
    public int PageView { get; set; }

    /// <summary>
    /// 是否公开
    /// </summary>
    public bool IsPublic { get; set; }

    /// <summary>
    /// 文档状态
    /// </summary>
    public EKnowledgeStatus Status { get; set; }

    /// <summary>
    /// 是否上架
    /// </summary>
    public bool IsOnShelf { get; set; }

    /// <summary>
    /// 上架时间
    /// </summary>
    public DateTime? OnShelfTime { get; set; }

    /// <summary>
    /// 下架时间
    /// </summary>
    public DateTime? OffShelfTime { get; set; }

    /// <summary>
    /// 关键词
    /// </summary>
    public string Keywords { get; set; }

    /// <summary>
    /// 附件
    /// </summary>
    [SugarColumn(ColumnDataType = "varchar(1000)", IsJson = true)]
    public List<string> Additions { get; set; }

    /// <summary>
    /// 关联知识申请
    /// </summary>
    [SugarColumn(ColumnDataType = "varchar(2000)", IsJson = true)]
    public List<string> Applies { get; set; }

    /// <summary>
    /// 关联知识
    /// </summary>
    [SugarColumn(ColumnDataType = "varchar(2000)", IsJson = true)]
    public List<string> Knowledges { get; set; }

}