﻿using XF.Domain.Dependency;
using XF.Domain.Exceptions;

namespace Hotline.Orders
{
    public class CommonOpinionDomainService : ICommonOpinionDomainService, IScopeDependency
    {
        private readonly ICommonOpinionRepository _commonOpinionRepository;

        public CommonOpinionDomainService(ICommonOpinionRepository commonOpinionRepository)
        {
            _commonOpinionRepository = commonOpinionRepository;
        }
        public async Task AddCommonOpinion(CommonOpinion entity,CancellationToken cancellationToken)
        {
            await _commonOpinionRepository.AddAsync(entity, cancellationToken);
        }

        public async Task<IReadOnlyList<CommonOpinion>> GetCommonOpinions(string code)
        {
            //TODO 加权限
            return await _commonOpinionRepository.Queryable().Where(x => x.TypeCode == code).ToListAsync();
        }

        public async Task DelCommonOpinion(string[] Ids,CancellationToken cancellationToken)
        {
            //TODO 加权限
            var list =await _commonOpinionRepository.Queryable().In(Ids).ToListAsync();
            if (list.Count!=Ids.Length)
            {
                throw new UserFriendlyException("数据异常，无权限操作");
            }
            await _commonOpinionRepository.RemoveRangeAsync(list,cancellationToken);
        }
    }
}
