﻿using Hotline.Share.Enums.Order;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.Orders
{
    public class TimeLimit: CreationEntity
    {

        public string TimeLimitName { get; set; }

        public string WorkflowName { get; set; }
        
        public string WorkflowCode { get; set; }

        public ETimeLimitState TimeLimitState { get; set; }

        [SugarColumn(ColumnDataType = "longtext", IsJson = true,IsNullable = true)]
        public List<ParamTypeModel>? ParamArr { get; set; }

        /// <summary>
        /// 排序
        /// </summary>
        [SugarColumn(ColumnDataType = "longtext", IsJson = true,IsNullable = true)]
        public List<PriorityModel>? Priority { get; set; }

        /// <summary>
        /// 组合
        /// </summary>
        [SugarColumn(ColumnDataType = "longtext", IsJson = true,IsNullable = true)]
        public List<CombinationModel>? Combination { get; set; }


    }

    public class CombinationModel
    {
        /// <summary>
        /// 组合ID
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 组合名称
        /// </summary>
        public string CombinationName { get; set; }


        /// <summary>
        /// 组合参数
        /// </summary>
        public List<CombinationParamModel> CombinationParam { get; set; }


        /// <summary>
        /// 时限
        /// </summary>
        public int TimeLimitValue { get; set; }
        /// <summary>
        /// 时限类型
        /// </summary>
        public string TimeLimit { get; set; }

        /// <summary>
        /// 换算时间（小时）
        /// </summary>
        public int Hour { get; set; }
    }


    public class CombinationParamModel
    {
        public string Id { get; set; }

        public string ParamName { get; set; }
    }



    public class PriorityModel
    {
        public string Id { get; set; }

        public string ParamTypeName { get; set; }

        public int Sort { get; set; }
    }


    public class ParamTypeModel
    {
        public string ParamType { get; set; }

        public List<ParamValueModel> ParamValue { get; set; }
    }

    public class ParamValueModel
    {
        public string Id { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string ParamTypeName { get; set; }
        /// <summary>
        /// 时限
        /// </summary>
        public int TimeLimitValue { get; set; }
        /// <summary>
        /// 时限类型
        /// </summary>
        public string TimeLimit { get; set; }

        /// <summary>
        /// 换算时间（小时）
        /// </summary>
        public int Hour { get; set; }
    }
}
