﻿using Hotline.Share.Dtos.Menu;
using XF.Domain.Repository;

namespace Hotline.Settings
{
    public interface ISystemMenuRepository: IRepository<SystemMenu>
    {
        Task<IReadOnlyList<SystemMenu>> GetSystemMenus();

        /// <summary>
        /// 获取可选快速入口
        /// </summary>
        /// <param name="roles"></param>
        /// <returns></returns>
        Task<IReadOnlyList<SystemMenu>> GetFastMenu(string[] roles,string userId,string name);

        /// <summary>
        /// 获取我的快速入口
        /// </summary>
        /// <param name="roles"></param>
        /// <param name="userId"></param>
        /// <returns></returns>
        Task<IReadOnlyList<SystemMenu>> GetMyFastMenu(string[] roles,string userId);
    }
}
