﻿using XF.Domain.Dependency;

namespace Hotline.Settings
{
    public class SystemAreaDomainService : ISystemAreaDomainService, IScopeDependency
    {
        private readonly ISystemAreaRepository _systemAreaRepository;

        public SystemAreaDomainService(ISystemAreaRepository systemAreaRepository)
        {
            _systemAreaRepository = systemAreaRepository;
        }

        public async Task<List<SystemArea>> GetAreaTree()
        {
           return await  _systemAreaRepository.Queryable().ToTreeAsync(x => x.Children,q=>q.ParentId, "");
        }
    }
}
