﻿using SqlSugar;
using System.ComponentModel;
using XF.Domain.Entities;
using XF.Domain.Repository;

namespace Hotline.Settings
{
    [Description("权限分配")]
    public class SystemAuthority: CreationEntity
    {
        /// <summary>
        /// 角色ID
        /// </summary>
        public string RoleId { get; set; }

        /// <summary>
        /// 角色Code
        /// </summary>
        public string RoleCode { get; set; }

        /// <summary>
        /// 菜单ID
        /// </summary>
        [SugarColumn(ColumnDataType="varchar(3000)",IsJson = true)]
        public List<string> SystemMenuArr { get; set; }

        /// <summary>
        /// 功能点
        /// </summary>
        [SugarColumn(ColumnDataType = "varchar(4000)",IsJson = true)]
        public List<string> SystemButtonArr { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime CreationTime { get; set; }
    }

    public class SystemMenuAuth
    {
        public string mcode { get; set; }

        public string mname { get; set; }

        public List<SystemMenuAuth> child { get; set; }

        public List<SystemButtonAuth> btnarr { get; set; }
    }

    public class SystemButtonAuth
    {
        public string bcode { get; set; }

        public string bname { get; set; }
    }
}
