﻿using System.Security.Authentication;

namespace XF.Domain.Authentications;

public interface ISessionContext
{
    /// <summary>
    /// Id of current tenant or null for host
    /// </summary>
    string? UserId { get; }

    /// <summary>
    /// Id of current user or throw Exception for guest
    /// </summary>
    /// <exception cref="AuthenticationException"></exception>
    string RequiredUserId { get; }

    string? UserName { get; }

    string? Phone { get; }

    /// <summary>
    /// Roles
    /// </summary>
    string[] Roles { get; }

    ///// <summary>
    ///// Return the first value of the specific <see cref="claimType"/> claim type, otherwise null if the claim is not present.
    ///// </summary>
    ///// <param name="claimType"></param>
    ///// <returns></returns>
    //string? FindFirstValue(string claimType);

    string? OrgId { get; set; }
    string? OrgCode { get; set; }
    string? OrgName { get; set; }

    string RequiredOrgId { get; }
    string RequiredOrgCode { get; }
}

