﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Exceptions;

namespace XF.Domain.Extensions
{
    public static class OrgExtensions
    {
        public static List<string> GetHigherOrgCodes(this string orgCode, bool withSelf = false)
        {
            if (string.IsNullOrEmpty(orgCode))
                return new();
            var length = orgCode.Length;
            if (length % 3 != 0)
                throw new UserFriendlyException($"非法OrgCode, code: {orgCode}");

            var rsp = new List<string>();
            if (withSelf)
                rsp.Add(orgCode);
            var code = orgCode.Substring(0, length - 3);
            while (code.Length > 0)
            {
                rsp.Add(code);
                code = code.Substring(0, code.Length - 3);
            }
            return rsp;
        }
    }
}
