﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Identity;

namespace XF.Domain.Options
{
    public class IdentityConfiguration : IdentityOptions
    {
        public AccountOptions Account { get; set; }
        public JwtOptions Jwt { get; set; }
    }

    public class AccountOptions
    {
        public string DefaultPassword { get; set; }
    }

    public class JwtOptions
    {
        public string SecretKey { get; set; }
        public string Issuer { get; set; }
        public string Audience { get; set; }
        public string Scope { get; set; }
        public int Expired { get; set; }
    }
}
